<?php
/*
 * -----------------------------------------------------------------------------
 * Plugin Name: GMaps
 * -----------------------------------------------------------------------------
 * Author     : Grum
 *   email    : grum@piwigo.org
 *   website  : http://photos.grum.fr
 *   PWG user : http://forum.piwigo.org/profile.php?id=3706
 *
 *   << May the Little SpaceFrog be with you ! >>
 *
 * -----------------------------------------------------------------------------
 *
 * See main.inc.php for release information
 *
 * manage all the ajax requests
 * -----------------------------------------------------------------------------
 */

  define('PHPWG_ROOT_PATH',dirname(dirname(dirname(__FILE__))).'/');

  /*
   * set ajax module in admin mode if request is used for admin interface
   */
  if(!isset($_REQUEST['ajaxfct'])) $_REQUEST['ajaxfct']='';
  if(preg_match('/^admin\./i', $_REQUEST['ajaxfct']))
  {
    define('IN_ADMIN', true);
  }

  // the common.inc.php file loads all the main.inc.php plugins files
  include_once(PHPWG_ROOT_PATH.'include/common.inc.php' );
  include_once(PHPWG_PLUGINS_PATH.'GrumPluginClasses/classes/GPCAjax.class.inc.php');
  include_once('gmaps_root.class.inc.php');

  load_language('plugin.lang', GMAPS_PATH);


  class GMaps_Ajax extends GMaps_root
  {
    /**
     * constructor
     */
    public function __construct($prefixeTable, $filelocation)
    {
      parent::__construct($prefixeTable, $filelocation);
      $this->loadConfig();
      $this->checkRequest();
      $this->returnAjaxContent();
    }

    /**
     * check the $_REQUEST values and set default values
     *
     */
    protected function checkRequest()
    {
      global $user;

      if(!isset($_REQUEST['ajaxfct'])) $_REQUEST['ajaxfct']='';

      // check if asked function is valid
      if(!($_REQUEST['ajaxfct']=='admin.maps.getList' or
           $_REQUEST['ajaxfct']=='admin.maps.setMap' or
           $_REQUEST['ajaxfct']=='admin.maps.getMap' or
           $_REQUEST['ajaxfct']=='admin.maps.deleteMap' or
           $_REQUEST['ajaxfct']=='admin.assoc.getList' or
           $_REQUEST['ajaxfct']=='admin.assoc.setAssoc' or
           $_REQUEST['ajaxfct']=='admin.assoc.getAssoc' or
           $_REQUEST['ajaxfct']=='admin.assoc.deleteAssoc' or

           $_REQUEST['ajaxfct']=='public.maps.init' or
           $_REQUEST['ajaxfct']=='public.maps.getMarkers' //or
           //$_REQUEST['ajaxfct']=='public.maps.getMarkerInfos'
           )) $_REQUEST['ajaxfct']='';

      if(preg_match('/^admin\./i', $_REQUEST['ajaxfct']) and !is_admin()) $_REQUEST['ajaxfct']='';


      if($_REQUEST['ajaxfct']!='')
      {
        /*
         * no check for admin.maps.getList & admin.assoc.getList requests
         */


        /*
         * check admin.maps.getMap & admin.assoc.getAssoc values
         */
        if($_REQUEST['ajaxfct']=="admin.maps.getMap" or
           $_REQUEST['ajaxfct']=="admin.assoc.getAssoc")
        {
          if(!isset($_REQUEST['id']) or
             !is_numeric($_REQUEST['id']) or
             $_REQUEST['id']=='') $_REQUEST['ajaxfct']='';
        }

        /*
         * check admin.maps.deleteMap values
         */
        if($_REQUEST['ajaxfct']=="admin.maps.deleteMap" or
           $_REQUEST['ajaxfct']=="admin.maps.deleteAssoc")
        {
          if(!isset($_REQUEST['id']) or
             !is_numeric($_REQUEST['id']) or
             $_REQUEST['id']=='') $_REQUEST['ajaxfct']='';
        }

        /*
         * check admin.maps.setMap values
         */
        if($_REQUEST['ajaxfct']=="admin.maps.setMap")
        {
          if(!isset($_REQUEST['id']) or
             !isset($_REQUEST['datas']) or !is_array($_REQUEST['datas']))
          {
            $_REQUEST['ajaxfct']='';
          }
          else
          {
            if(!(isset($_REQUEST['datas']['displayType']) &&
                 isset($_REQUEST['datas']['sizeMode']) &&
                 isset($_REQUEST['datas']['name']) &&
                 isset($_REQUEST['datas']['width']) &&
                 isset($_REQUEST['datas']['height']) &&
                 isset($_REQUEST['datas']['zoomLevel']) &&
                 isset($_REQUEST['datas']['mapType']) &&
                 isset($_REQUEST['datas']['mapTypeControl']) &&
                 isset($_REQUEST['datas']['navigationControl']) &&
                 isset($_REQUEST['datas']['scaleControl']) &&
                 isset($_REQUEST['datas']['style'])))
            {
              $_REQUEST['ajaxfct']='';
            }
            else
            {
              if(!($_REQUEST['datas']['displayType']=='IC' or
                  $_REQUEST['datas']['displayType']=='IP' or
                  $_REQUEST['datas']['displayType']=='MP')) $_REQUEST['ajaxfct']='';

              if(!($_REQUEST['datas']['sizeMode']=='A' or
                  $_REQUEST['datas']['sizeMode']=='F')) $_REQUEST['ajaxfct']='';

              if(!is_numeric($_REQUEST['datas']['width']) or
                  $_REQUEST['datas']['width']<100 or
                  $_REQUEST['datas']['width']>1280) $_REQUEST['datas']['width']=470;

              if(!is_numeric($_REQUEST['datas']['height']) or
                  $_REQUEST['datas']['height']<100 or
                  $_REQUEST['datas']['height']>1280) $_REQUEST['datas']['height']=210;

              if(!is_numeric($_REQUEST['datas']['zoomLevel']) or
                  $_REQUEST['datas']['zoomLevel']<1 or
                  $_REQUEST['datas']['zoomLevel']>20) $_REQUEST['datas']['zoomLevel']=4;

              if(!($_REQUEST['datas']['mapType']=='hybrid' or
                  $_REQUEST['datas']['mapType']=='terrain' or
                  $_REQUEST['datas']['mapType']=='roadmap' or
                  $_REQUEST['datas']['mapType']=='satellite')) $_REQUEST['datas']['mapType']='hybrid';

              if(!is_numeric($_REQUEST['datas']['mapTypeControl']) or
                  $_REQUEST['datas']['mapTypeControl']<-1 or
                  $_REQUEST['datas']['mapTypeControl']>2) $_REQUEST['datas']['mapTypeControl']=0;

              if(!is_numeric($_REQUEST['datas']['navigationControl']) or
                  $_REQUEST['datas']['navigationControl']<-1 or
                  $_REQUEST['datas']['navigationControl']>3) $_REQUEST['datas']['navigationControl']=0;

              if(!($_REQUEST['datas']['scaleControl']=='y' or
                   $_REQUEST['datas']['scaleControl']=='n')) $_REQUEST['datas']['scaleControl']='y';
            }
          }
        }


        /*
         * check admin.maps.setAssoc values
         */
        if($_REQUEST['ajaxfct']=="admin.assoc.setAssoc")
        {
          if(!isset($_REQUEST['id']) or
             !isset($_REQUEST['datas']) or !is_array($_REQUEST['datas']))
          {
            $_REQUEST['ajaxfct']='';
          }
          else
          {
            if(!(isset($_REQUEST['datas']['categoryId']) &&
                 isset($_REQUEST['datas']['mapId']) &&
                 isset($_REQUEST['datas']['applySubCat']) &&
                 isset($_REQUEST['datas']['kmlFileUrl']) &&
                 isset($_REQUEST['datas']['icon']) &&
                 isset($_REQUEST['datas']['title']) ))
            {
              $_REQUEST['ajaxfct']='';
            }
            else
            {
              if($_REQUEST['datas']['categoryId']=='' or
                 $_REQUEST['datas']['categoryId']<0) $_REQUEST['ajaxfct']='';

              if($_REQUEST['datas']['mapId']=='') $_REQUEST['ajaxfct']='';

              if(!($_REQUEST['datas']['applySubCat']=='y' or
                   $_REQUEST['datas']['applySubCat']=='n')) $_REQUEST['datas']['applySubCat']='y';
            }
          }
        }


        /*
         * check public.maps.getMarkers values
         */
        if($_REQUEST['ajaxfct']=="public.maps.getMarkers")
        {
          if(!isset($_REQUEST['datas']) or
             !is_array($_REQUEST['datas']))
          {
            $_REQUEST['ajaxfct']='';
          }
          else
          {
            if(!(isset($_REQUEST['datas']['requestId']) &&
                 isset($_REQUEST['datas']['bounds']) &&
                 isset($_REQUEST['datas']['width']) &&
                 isset($_REQUEST['datas']['height']) &&
                 isset($_REQUEST['datas']['distanceTreshold']) &&
                 isset($_REQUEST['datas']['bounds']['north']) &&
                 isset($_REQUEST['datas']['bounds']['south']) &&
                 isset($_REQUEST['datas']['bounds']['east']) &&
                 isset($_REQUEST['datas']['bounds']['west']) ))
            {
              $_REQUEST['ajaxfct']='';
            }
            else
            {
              if(!isset($_REQUEST['datas']['levelInfo'])) $_REQUEST['datas']['levelInfo']=1;

              if(!($_REQUEST['datas']['levelInfo']==0 or
                   $_REQUEST['datas']['levelInfo']==1)) $_REQUEST['datas']['levelInfo']=1;
            }
          }
        }

        /*
         * check public.maps.getMarkerInfos values
         */
        if($_REQUEST['ajaxfct']=="public.maps.init")
        {
          if(!isset($_REQUEST['category']))
          {
            $_REQUEST['ajaxfct']='';
          }


        }

      }
    } //checkRequest


    /**
     * return ajax content
     */
    protected function returnAjaxContent()
    {
      $result="<p class='errors'>An error has occured</p>";
      switch($_REQUEST['ajaxfct'])
      {
        case 'admin.maps.getList':
          $result=$this->ajax_gmaps_admin_mapsGetList();
          break;
        case 'admin.maps.getMap':
          $result=$this->ajax_gmaps_admin_mapsGetMap($_REQUEST['id']);
          break;
        case 'admin.maps.setMap':
          $result=$this->ajax_gmaps_admin_mapsSetMap($_REQUEST['id'], $_REQUEST['datas']);
          break;
        case 'admin.maps.deleteMap':
          $result=$this->ajax_gmaps_admin_mapsDeleteMap($_REQUEST['id']);
          break;
        case 'admin.assoc.getList':
          $result=$this->ajax_gmaps_admin_assocGetList();
          break;
        case 'admin.assoc.getAssoc':
          $result=$this->ajax_gmaps_admin_assocGetAssoc($_REQUEST['id']);
          break;
        case 'admin.assoc.setAssoc':
          $result=$this->ajax_gmaps_admin_assocSetAssoc($_REQUEST['id'], $_REQUEST['datas']);
          break;
        case 'admin.assoc.deleteAssoc':
          $result=$this->ajax_gmaps_admin_assocDeleteAssoc($_REQUEST['id']);
          break;

        case 'public.maps.init':
          $result=$this->ajax_gmaps_public_mapsInit($_REQUEST['category']);
          break;
        case 'public.maps.getMarkers':
          $result=$this->ajax_gmaps_public_mapsGetMarkers($_REQUEST['datas']);
          break;
      }
      GPCAjax::returnResult($result);
    }


    /*------------------------------------------------------------------------*
     *
     * ADMIN FUNCTIONS
     *
     *----------------------------------------------------------------------- */

    /**
     * return a HTML list of defined maps
     *
     * @return String
     */
    private function ajax_gmaps_admin_mapsGetList()
    {
      global $template;

      $template->set_filename('list_page',
                    dirname($this->getFileLocation()).'/admin/gmaps_maps_iListMaps.tpl');

      $datas=Array();

      $sql="SELECT id, name, displayType, sizeMode, width, height, zoomLevel, mapType, mapTypeControl, navigationControl, scaleControl
            FROM ".$this->tables['maps']."
            ORDER BY displayType ASC, name ASC";
      $result=pwg_query($sql);
      if($result)
      {
        while($row=pwg_db_fetch_assoc($result))
        {
          if($row['displayType']=='IC')
          {
            $row['zoomLevel']=l10n('gmaps_auto');
          }

          $row['displayType']=l10n('gmaps_displayTypeShort'.$row['displayType']);

          if($row['sizeMode']=='A')
          {
            $row['dimensions']=l10n('gmaps_auto');
          }
          else
          {
            $row['dimensions']=$row['width'].'x'.$row['height'];
          }

          $row['mapType']=l10n('gmaps_googleMapType_'.$row['mapType']);
          $row['mapTypeControl']=l10n('gmaps_googleMapTypeControl_'.$row['mapTypeControl']);
          $row['navigationControl']=l10n('gmaps_googleMapNavigationControl_'.$row['navigationControl']);
          $row['scaleControl']=($row['scaleControl']=='y')?l10n('gmaps_display_visible'):l10n('gmaps_display_hidden');
          $datas[]=$row;
        }
      }

      $template->assign('datas', $datas);
      return($template->parse('list_page', true));
    } //ajax_gmaps_admin_mapsGetList


    /**
     * set properties for a given map id ; if no map id is given, create a new
     * map
     *
     * @param String id : the map Id
     * @param Array datas : properties of the map (assuming array index were
     *                      checked by the checkRequest function)
     * @return String : the num id, or an error message
     */
    private function ajax_gmaps_admin_mapsSetMap($id, $properties)
    {
      global $template;

      if($id=='')
      {
        $sql="INSERT INTO ".$this->tables['maps']."
              VALUES ('', '".mysql_escape_string($properties['name'])."', '".
                $properties['displayType']."', '".
                $properties['sizeMode']."', '".
                $properties['width']."', '".
                $properties['height']."', '".
                $properties['zoomLevel']."', '".
                $properties['mapType']."', '".
                $properties['mapTypeControl']."', '".
                $properties['navigationControl']."', '".
                $properties['scaleControl']."', '".
                mysql_escape_string($properties['style'])."');";
        $result=pwg_query($sql);
        $id=pwg_db_insert_id();
      }
      else
      {
        $sql="UPDATE ".$this->tables['maps']."
              SET name='".mysql_escape_string($properties['name'])."', displayType='".
                $properties['displayType']."', sizeMode='".
                $properties['sizeMode']."', width='".
                $properties['mapId']."', width='".
                $properties['width']."', height='".
                $properties['height']."', zoomLevel='".
                $properties['zoomLevel']."', mapType='".
                $properties['mapType']."', mapTypeControl='".
                $properties['mapTypeControl']."', navigationControl='".
                $properties['navigationControl']."', scaleControl='".
                $properties['scaleControl']."', style='".
                mysql_escape_string($properties['style'])."'
              WHERE id='$id';";
        $result=pwg_query($sql);
      }

      return($id);
    } //ajax_gmaps_admin_mapsSetMap


    /**
     * get properties for a given map id
     *
     * @param String id : the map Id
     * @return String : data formatted in a JSON string
     */
    private function ajax_gmaps_admin_mapsGetMap($id)
    {
      $returned=array(
        'id' => '',
        'name' => '',
        'displayType' => '',
        'sizeMode' => '',
        'width' => 470,
        'height' => 210,
        'zoomLevel' => 4,
        'mapType' => 'hybrid',
        'mapTypeControl' => 0,
        'navigationControl' => 0,
        'scaleControl' => 'y'
      );

      $sql="SELECT id, displayType, sizeMode, name, width, height, zoomLevel, mapType, mapTypeControl, navigationControl, scaleControl
            FROM ".$this->tables['maps']."
            WHERE id='$id';";
      $result=pwg_query($sql);
      if($result)
      {
        while($row=pwg_db_fetch_assoc($result))
        {
          $returned=$row;
        }
      }

      return(json_encode($returned));
    } //ajax_gmaps_admin_mapsGetMap



    /**
     * delete a map
     *
     * @param String id : if of the map to delete
     * @return String : ok or ko
     */
    private function ajax_gmaps_admin_mapsDeleteMap($id)
    {
      $sql="DELETE FROM ".$this->tables['maps']."
            WHERE id='$id';";
      $result=pwg_query($sql);
      if($result)
      {
        $sql="DELETE FROM ".$this->tables['category_maps']."
              WHERE map_id='$id';";
        $result=pwg_query($sql);
        if($result) return('ok');
      }

      return('ko!unknown error');
    } //ajax_gmaps_admin_mapsDeleteMap





    /**
     * return a HTML list of defined associations
     *
     * @return String
     */
    private function ajax_gmaps_admin_assocGetList()
    {
      global $template;

      $template->set_filename('list_page',
                    dirname($this->getFileLocation()).'/admin/gmaps_category_maps_iListMaps.tpl');

      $datas=Array();

      $sql="SELECT pgcm.id, pgcm.categoryId, pct.name AS catName,
                   pgmm.name AS mapName, pgmm.displayType,
                   pgcm.kmlFileUrl, pgcm.imgSort, pgcm.applySubCat, pgcm.icon,
                   pgcm.title
            FROM (".$this->tables['category_maps']." pgcm
                  LEFT JOIN ".CATEGORIES_TABLE." pct ON pct.id=pgcm.categoryId)
                  LEFT JOIN ".$this->tables['maps']." pgmm ON pgcm.mapId = pgmm.id
            ORDER BY pct.name, pgmm.displayType, pgcm.imgSort";
      $result=pwg_query($sql);
      if($result)
      {
        $keys=array(
          'prev' => '',
          'curr' => ''
        );
        while($row=pwg_db_fetch_assoc($result))
        {
          $keys['prev']=$keys['curr'];

          $tmp=array(
            'id' => $row['id'],
            'catName' => ($row['categoryId']==0)?l10n('gmaps_applyForAllTheGallery'):$row['catName'],
            'applySubCat' => l10n('gmaps_'.$row['applySubCat']),
            'mapName' => $row['mapName'],
            'mapKmlFile' => l10n('gmaps_'.(($row['kmlFileUrl']=='')?'n':'y')),
            'icon' => $row['icon'],
            'displayType' => l10n('gmaps_displayTypeShort'.$row['displayType']),
            'title' => $row['title']
          );

          $keys['curr']=$row['categoryId'].$row['displayType'];

          if($keys['curr']==$keys['prev'])
          {
            $tmp['catName']='';
            $tmp['displayType']='';
            $tmp['applySubCat']='';
          }

          $datas[]=$tmp;
        }
      }

      $template->assign('datas', $datas);
      return($template->parse('list_page', true));
    } //ajax_gmaps_admin_assocGetList




    /**
     * set properties for a given association id ; if no association id is given
     * create a new association
     *
     * @param String id : the association Id
     * @param Array datas : properties of the association (assuming array index
     *                      were checked by the checkRequest function)
     * @return String : the num id, or an error message
     */
    private function ajax_gmaps_admin_assocSetAssoc($id, $properties)
    {
      global $template;

      // if create a new assoc, get the last imgSort
      $db=array(
        'nbId' => 0,
        'displayType' => '',
        'maxImgSort' => 0
      );

      $sql="SELECT MAX(imgSort) AS maxImgSort, pgmm.displayType, COUNT(pgcm.id) AS nbId
            FROM (".$this->tables['category_maps']." pgcm
              LEFT JOIN ".$this->tables['maps']." pgmm ON pgmm.id = pgcm.mapId)
              LEFT JOIN ".$this->tables['maps']." pgmm2 ON pgmm2.displayType=pgmm.displayType

            WHERE categoryId='".$properties['categoryId']."'
              AND pgmm2.id='".$properties['mapId']."'
            GROUP BY pgmm.displayType;";
      $result=pwg_query($sql);
      if($result)
      {
        while($row=pwg_db_fetch_assoc($result))
        {
          $db=$row;
        }
      }

      if($id=='' and
          ($db['displayType']=='IC' or $db['displayType']=='IP') and
          $db['nbId']>0
        )
      {
        return('!'.l10n('gmaps_only_one_map_is_allowed_for_this_mode'));
      }


      if($id=='')
      {
        $sql="INSERT INTO ".$this->tables['category_maps']."
              VALUES ('', '".
                $properties['categoryId']."', '".
                $properties['mapId']."', '".
                ($db['maxImgSort']+1)."', '".
                $properties['applySubCat']."', '".
                $properties['kmlFileUrl']."', '".
                $properties['icon']."', '".
                mysql_escape_string($properties['title'])."');";
        $result=pwg_query($sql);
        $id=pwg_db_insert_id();
      }
      else
      {
        $sql="UPDATE ".$this->tables['category_maps']."
              SET categoryId='".
                $properties['categoryId']."', mapId='".
                $properties['mapId']."', applySubCat='".
                $properties['applySubCat']."', kmlFileUrl='".
                $properties['kmlFileUrl']."', icon='".
                $properties['icon']."', title='".
                mysql_escape_string($properties['title'])."'
              WHERE id='$id';";
        $result=pwg_query($sql);
      }

      return($id);
    } //ajax_gmaps_admin_assocSetAssoc




    /**
     * get properties for a given association id
     *
     * @param String id : the association Id
     * @return String : data formatted in a JSON string
     */
    private function ajax_gmaps_admin_assocGetAssoc($id)
    {
      $returned=array(
        'id' => '',
        'categoryId' => 0,
        'mapId' => '',
        'applySubCat'=> 'y',
        'kmlFileUrl' => '',
        'icon' => '',
        'title' => ''
      );

      $sql="SELECT id, categoryId, mapId, applySubCat, kmlFileUrl,
                   icon, title
            FROM ".$this->tables['category_maps']."
            WHERE id='$id';";
      $result=pwg_query($sql);
      if($result)
      {
        while($row=pwg_db_fetch_assoc($result))
        {
          $returned=$row;
        }
      }

      return(json_encode($returned));
    } //ajax_gmaps_admin_assocGetAssoc




    /**
     * delete an association
     *
     * @param String id : if of the association to delete
     * @return String : ok or ko
     */
    private function ajax_gmaps_admin_assocDeleteAssoc($id)
    {
      $sql="DELETE FROM ".$this->tables['category_maps']."
            WHERE id='$id';";
      $result=pwg_query($sql);
      if($result) return('ok');

      return('ko!unknown error');
    } //ajax_gmaps_admin_assocDeleteAssoc


    /**
     * prepare the cache for the user / category
     *
     *
     * @param Integer $category : the category Id, 0 if want to init map for all
     *                            the gallery
     * @return String : the requestId
     */
    private function ajax_gmaps_public_mapsInit($category)
    {
      global $prefixeTable, $template, $user, $conf;

      $returned='';

      $this->buildMapList($category, 'C');
      if($category>0)
      {
        $sqlCatRestrict="AND FIND_IN_SET($category, pct.uppercats)!=0";
      }
      else
      {
        $sqlCatRestrict="";
      }

      if(count($this->maps)>0)
      {
        $scripts=array();
        $bounds=array(
          'N' => -90,
          'S' => 90,
          'E' => -180,
          'W' => 180
        );

        // there is some maps to display
        $requestId=date('Y-m-d h:i:s');

        // delete cache (for user and data having more than 24h)
        $sql="DELETE FROM ".$this->tables['cache']."
              WHERE userId='".$user['id']."'
                 OR requestId<'".date('Y-m-d h:i:s', time()-86400)."';";
        pwg_query($sql);

        // prepare the cache (same request in the 'GMaps_pip->displayCategoryPageMap' function)
        $sql="SELECT DISTINCT pic.image_id, GROUP_CONCAT(DISTINCT pait.value ORDER BY pait.numID ASC SEPARATOR ';') AS coords,
                GROUP_CONCAT(DISTINCT pic.category_id ORDER BY pic.category_id SEPARATOR ';') AS imageCatsId,
                GROUP_CONCAT(DISTINCT pct.name ORDER BY pct.id SEPARATOR ';') AS imageCatsNames,
                GROUP_CONCAT(DISTINCT IF(pct.permalink IS NULL, CONCAT('*', pct.id), pct.permalink) ORDER BY pct.id SEPARATOR ';') AS imageCatsPLink,
                pit.name AS imageName, pit.path, pit.tn_ext
              FROM ((((".USER_CACHE_CATEGORIES_TABLE." pucc
                LEFT JOIN ".CATEGORIES_TABLE." pct ON pucc.cat_id = pct.id)
                LEFT JOIN ".IMAGE_CATEGORY_TABLE." pic ON pic.category_id = pucc.cat_id)
                LEFT JOIN ".$prefixeTable."amd_images_tags pait ON pait.imageId = pic.image_id)
                LEFT JOIN ".$prefixeTable."amd_used_tags paut ON pait.numId = paut.numId)
                LEFT JOIN ".IMAGES_TABLE." pit ON pit.id = pic.image_id
              WHERE pucc.user_id = '".$user['id']."'
               AND (paut.tagId = 'magic.GPS.LatitudeNum' OR paut.tagId = 'magic.GPS.LongitudeNum')
               AND pic.image_id IS NOT NULL
               $sqlCatRestrict
               GROUP BY pic.image_id";
/*
 * get_sql_condition_FandF(
                array
                  (
                    'forbidden_categories' => 'pic.category_id',
                    'visible_categories' => 'pic.category_id',
                    'visible_images' => 'pic.image_id'
                  ),
                'AND'
              );
*/
        $result=pwg_query($sql);
        if($result)
        {
          $massInsert=array();

          while($row=pwg_db_fetch_assoc($result))
          {
            $coords=explode(';', $row['coords']);
            $this->updateBounds($bounds, array(
                'lat' => $coords[0],
                'lng' => $coords[1]
              )
            );

            $massInsert[]=array(
              'userId' => $user['id'],
              'requestId' => $requestId,
              'imageId' => $row['image_id'],
              'latitude' => $coords[0],
              'longitude' => $coords[1],
              'imageName' => mysql_escape_string($row['imageName']),
              'imageTnFile' => dirname($row['path']).'/'.$conf['dir_thumbnail'].'/'.$conf['prefix_thumbnail'].get_filename_wo_extension(basename($row['path'])).'.'.$row['tn_ext'],
              'imageCatsId' => $row['imageCatsId'],
              'imageCatsNames' => mysql_escape_string($row['imageCatsNames']),
              'imageCatsPLink' => $row['imageCatsPLink']
            );
          }

          mass_inserts($this->tables['cache'], array('userId', 'requestId', 'imageId', 'latitude', 'longitude', 'imageName', 'imageTnFile', 'imageCatsId', 'imageCatsNames', 'imageCatsPLink'), $massInsert);

          $returned=$requestId;
        }
      }

      return($requestId);
    }


    /**
     * returns a list of markers
     *
     *
     * @param Array $datas : 'requestId' id of the request
     *                       'bounds'  (north, east, west, south) : only markers
     *                          inside the given bounds are returned
     *                       'width' : width of maps in pixels
     *                       'height' : height of maps in pixels
     *                       'levelInfo' : 0 = don't return pictures info (name, url, ...)
     *                                     1 = return pictures informations
     * @return Array|String : a JSON string of an array of points (nbPictures, lat, lng)
     */
    private function ajax_gmaps_public_mapsGetMarkers($datas)
    {
      global $user, $page;

      $returned=array(
        'markers' => array(),
        'datas' => array(
          'nbPhotos' => 0
        )
      );

      /*
       * the 'make_picture_url' function use the 'get_root_url' function which
       * use the $page['root_path'] value
       *
       * here, this $page index doesn't exist, so we need to initialize it
       */
      $page['root_path']='';

      if($datas['bounds']['east']<$datas['bounds']['west'])
      {
        /*  E = -xxx    W = +xxx
         *  a(lng E:+x)
         *  b(lng W:-x)
         *
         *  E         +180/-180     W
         * (+)                     (-)
         *  +-------------+---------+
         *  |             :         |
         *  |             :    b    |
         *  |     a       :         |
         *  |             :         |
         *  +-------------+---------+
         *
         */
        $lngClause="
              longitude <= ".$datas['bounds']['east']."
              OR longitude >= ".$datas['bounds']['west']." ";
      }
      else
      {
        /*  E = -xxx    W = +xxx
         *  a(lng W:-x)
         *  b(lng E:+x)
         *
         *  W             0         E
         * (-)                     (+)
         *  +-------------+---------+
         *  |             :         |
         *  |             :    b    |
         *  |      a      :         |
         *  |             :         |
         *  +-------------+---------+
         *
         */
        $lngClause="
              longitude >= ".$datas['bounds']['west']."
              AND longitude <= ".$datas['bounds']['east']." ";
      }

      $sql="SELECT latitude, longitude, imageId, imageCatsId, imageCatsNames, imageTnFile, imageName, imageCatsPLink
            FROM ".$this->tables['cache']."
            WHERE userId='".$user['id']."'
              AND requestId='".$datas['requestId']."'
              AND ($lngClause)
              AND latitude >= ".$datas['bounds']['south']."
              AND latitude <= ".$datas['bounds']['north']."
            ORDER BY latitude, longitude;";

      $result=pwg_query($sql);
      if($result)
      {
        // compute ratio map size / bound size
        $ratioW=($datas['bounds']['east']-$datas['bounds']['west'])/$datas['width'];
        $ratioH=($datas['bounds']['north']-$datas['bounds']['south'])/$datas['height'];
        // works with the highest ratio
        $ratio=max($ratioW, $ratioH);


        $points=array();
        $groups=array();

        while($row=pwg_db_fetch_assoc($result))
        {
          $points[]=$row;
        }

        /*
         *  build groups
         */
        while(count($points)>0)
        {
          $currentGroup=array();
          $currentGroup[]=array_shift($points);

          $i=0;
          while($i<count($points))
          {
            $dist=sqrt(pow($points[$i]['latitude']-$currentGroup[0]['latitude'],2) + pow($points[$i]['longitude']-$currentGroup[0]['longitude'],2))/$ratio;

            if($dist <= $datas['distanceTreshold'])
            {
              $tmp=array_splice($points, $i, 1);
              $currentGroup[]=$tmp[0];
              $points=array_values($points); // reset array index...
            }
            else
            {
              $i++;
            }
          }

          $groups[]=$currentGroup;
          unset($currentGroup);
        }

        /*
         * for each group, calculate coordinates for a unique representative
         * point
         */
        foreach($groups as $keyGroup => $group)
        {
          $coords=array(
            'nbImgTxt' => '',
            'nbImages' => 0,
            'lat' => 0,                   // 'lat' rather than 'latitude'
            'lng' => 0,                   // 'lng' rather than 'longitude'
            'imgTn' => array(),
            'imgCatsNames' => array(),
            'imgName' => array(),
            'imgCatsUrl' => array(),
          );

          foreach($group as $point)
          {
            $tmpCatsUrl=array();
            $tmpCatsId=explode(';', $point['imageCatsId']);
            $tmpCatsNames=explode(';', $point['imageCatsNames']);
            $tmpCatsPLinks=explode(';', $point['imageCatsPLink']);

            foreach($tmpCatsId as $key => $id)
            {
              $tmpCatsUrl[]=make_picture_url(
                array(
                  'image_id' => $point['imageId'],
                  'category' => array(
                    'id' => $id,
                    'name' => $tmpCatsNames[$key],
                    'permalink' => (substr($tmpCatsPLinks[$key],0,1)=='*')?'':$tmpCatsPLinks[$key],
                  )
                )
              );
            }

            if(count($tmpCatsId)<=1) $tmpCatsNames='';

            $coords['nbImages']++;

            $coords['lat']+=$point['latitude'];
            $coords['lng']+=$point['longitude'];

            if($datas['levelInfo']==1)
            {
              $coords['imgTn'][]=substr($point['imageTnFile'],12);
              $coords['imgCatsNames'][]=$tmpCatsNames;
              $coords['imgName'][]=$point['imageName'];
              $coords['imgCatsUrl'][]=$tmpCatsUrl;
            }
          }
          $coords['lat']=$coords['lat']/count($group);
          $coords['lng']=$coords['lng']/count($group);
          $coords['uniqueId']=md5($coords['lat'].$coords['lng']);

          if($coords['nbImages']==1)
          {
            $coords['nbImgTxt']=l10n('gmaps_1_picture');
          }
          else
          {
            $coords['nbImgTxt']=sprintf(l10n('gmaps_nb_pictures'), $coords['nbImages']);
          }



          $returned['markers'][]=$coords;
          $returned['datas']['nbPhotos']+=$coords['nbImages'];
        }
      }

      if($returned['datas']['nbPhotos']>1)
      {
        $returned['datas']['nbPhotos']=sprintf(l10n('gmaps_nb_pictures'), $returned['datas']['nbPhotos']);
      }
      else
      {
        $returned['datas']['nbPhotos']=l10n('gmaps_1_picture');
      }

      return(json_encode($returned));
    }


  } //class


  $returned=new GMaps_Ajax($prefixeTable, __FILE__);
?>
